build-psiphon-framework.sh 8.5 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236
  1. #!/usr/bin/env bash
  2. # This script takes one optional argument: 'private', if private plugins should
  3. # be used. It should be omitted if private plugins are not desired.
  4. if [[ $1 == "private" ]]; then
  5. FORCE_PRIVATE_PLUGINS=true
  6. echo "TRUE"
  7. else
  8. FORCE_PRIVATE_PLUGINS=false
  9. echo "FALSE"
  10. fi
  11. # -x echos commands. -u exits if an unintialized variable is used.
  12. # -e exits if a command returns an error.
  13. set -x -u -e
  14. # Reset the PATH to macOS default. This is mainly so we don't execute the wrong
  15. # gomobile executable.
  16. PATH=/usr/local/bin:/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/go/bin
  17. BASE_DIR=$(cd "$(dirname "$0")" ; pwd -P)
  18. cd ${BASE_DIR}
  19. # The location of the final framework build
  20. BUILD_DIR="${BASE_DIR}/build"
  21. # Ensure go is installed
  22. which go 2>&1 > /dev/null
  23. if [[ $? != 0 ]]; then
  24. echo "Go is not installed in the path, aborting"
  25. exit 1
  26. fi
  27. VALID_IOS_ARCHS="arm64 armv7 armv7s"
  28. VALID_SIMULATOR_ARCHS="x86_64"
  29. FRAMEWORK="Psi"
  30. INTERMEDIATE_OUPUT_DIR="${BASE_DIR}/PsiphonTunnel/PsiphonTunnel"
  31. INTERMEDIATE_OUPUT_FILE="${FRAMEWORK}.framework"
  32. FRAMEWORK_BINARY="${INTERMEDIATE_OUPUT_DIR}/${INTERMEDIATE_OUPUT_FILE}/Versions/A/${FRAMEWORK}"
  33. PRIVATE_PLUGINS_TAG=""
  34. if [[ ${FORCE_PRIVATE_PLUGINS} == true ]]; then PRIVATE_PLUGINS_TAG="PRIVATE_PLUGINS"; fi
  35. BUILD_TAGS="IOS ${PRIVATE_PLUGINS_TAG}"
  36. LIBSSL=${BASE_DIR}/OpenSSL-for-iPhone/lib/libssl.a
  37. LIBCRYPTO=${BASE_DIR}/OpenSSL-for-iPhone/lib/libcrypto.a
  38. OPENSSL_INCLUDE=${BASE_DIR}/OpenSSL-for-iPhone/include/
  39. UMBRELLA_FRAMEWORK_XCODE_PROJECT=${BASE_DIR}/PsiphonTunnel/PsiphonTunnel.xcodeproj/
  40. TRUSTED_ROOT_CA_FILE=${BASE_DIR}/PsiphonTunnel/PsiphonTunnel/rootCAs.txt
  41. # Download trustedroot CAs off curl website, see https://curl.haxx.se/docs/caextract.html for details
  42. curl -o $TRUSTED_ROOT_CA_FILE https://curl.haxx.se/ca/cacert.pem
  43. if [[ $? != 0 ]]; then
  44. echo "FAILURE: curl -o $TRUSTED_ROOT_CA_FILE https://curl.haxx.se/ca/cacert.pem"
  45. exit 1
  46. fi
  47. # Exporting these seems necessary for subcommands to pick them up.
  48. export GOPATH=${PWD}/go-ios-build
  49. export PATH=${GOPATH}/bin:${PATH}
  50. # The GOPATH we're using is temporary, so make sure there isn't one from a previous run.
  51. rm -rf ${GOPATH}
  52. GOMOBILE_PINNED_REV=eb9032959f05f108b05721914dfe09cfa0c5131d
  53. GOMOBILE_PATH=${GOPATH}/src/golang.org/x/mobile/cmd/gomobile
  54. TUNNEL_CORE_SRC_DIR=${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core
  55. OPENSSL_SRC_DIR=${GOPATH}/src/github.com/Psiphon-Inc/openssl
  56. PATH=${PATH}:${GOPATH}/bin
  57. mkdir -p ${GOPATH}
  58. if [[ $? != 0 ]]; then
  59. echo "FAILURE: mkdir -p ${GOPATH}"
  60. exit 1
  61. fi
  62. # Symlink the current source directory into GOPATH, so that we're building the
  63. # code in this local repo, rather than pulling from Github and building that.
  64. mkdir -p ${GOPATH}/src/github.com/Psiphon-Labs
  65. if [[ $? != 0 ]]; then
  66. echo "mkdir -p ${GOPATH}/src/github.com/Psiphon-Labs"
  67. exit 1
  68. fi
  69. ln -s "${BASE_DIR}/../.." "${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core"
  70. if [[ $? != 0 ]]; then
  71. echo "ln -s ../.. ${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core"
  72. exit 1
  73. fi
  74. mkdir -p ${INTERMEDIATE_OUPUT_DIR}
  75. if [[ $? != 0 ]]; then
  76. echo "FAILURE: mkdir -p ${INTERMEDIATE_OUPUT_DIR}"
  77. exit 1
  78. fi
  79. # arg: binary_path
  80. function strip_architectures() {
  81. valid_archs="${VALID_IOS_ARCHS} ${VALID_SIMULATOR_ARCHS}"
  82. ARCHS="$(lipo -info "$1" | rev | cut -d ':' -f1 | rev)"
  83. for ARCH in "${valid_archs}"; do
  84. if ! [[ "${valid_archs}" == *"$ARCH"* ]]; then
  85. echo "Stripping ARCH ${ARCH} from $1"
  86. lipo -remove "$ARCH" -output "$1" "$1"
  87. if [[ $? != 0 ]]; then
  88. echo "FAILURE: lipo $1"
  89. exit 1
  90. fi
  91. fi
  92. done
  93. return 0
  94. }
  95. cd OpenSSL-for-iPhone && ./build-libssl.sh; cd -
  96. strip_architectures "${LIBSSL}"
  97. strip_architectures "${LIBCRYPTO}"
  98. go get -d -u -v -tags "${BUILD_TAGS}" github.com/Psiphon-Inc/openssl
  99. if [[ $? != 0 ]]; then
  100. echo "FAILURE: go get -d -u -v -tags "${BUILD_TAGS}" github.com/Psiphon-Inc/openssl"
  101. exit 1
  102. fi
  103. # Don't use -u, because this path points to our local repo, and we don't want it overridden.
  104. go get -d -v -tags "${BUILD_TAGS}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi
  105. if [[ $? != 0 ]]; then
  106. echo "FAILURE: go get -d -v -tags "${BUILD_TAGS}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi"
  107. exit 1
  108. fi
  109. #
  110. # Get and install gomobile, using our pinned revision
  111. #
  112. go get -u golang.org/x/mobile/cmd/gomobile
  113. cd ${GOPATH}/src/golang.org/x/mobile/cmd/gomobile
  114. git checkout master
  115. git checkout -b pinned ${GOMOBILE_PINNED_REV}
  116. go install
  117. ${GOPATH}/bin/gomobile init -v -x
  118. if [[ $? != 0 ]]; then
  119. echo "FAILURE: ${GOPATH}/bin/gomobile init"
  120. exit 1
  121. fi
  122. #
  123. # gomobile bind
  124. #
  125. BUILDDATE=$(date +%Y-%m-%dT%H:%M:%S%z)
  126. BUILDREPO=$(git config --get remote.origin.url)
  127. BUILDREV=$(git rev-parse --short HEAD)
  128. GOVERSION=$(go version | perl -ne '/go version (.*?) / && print $1')
  129. GOMOBILEVERSION=$(${GOPATH}/bin/gomobile version | perl -ne '/gomobile version (.*?) / && print $1')
  130. # see DEPENDENCIES comment in MobileLibrary/Android/make.bash
  131. cd ${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi
  132. DEPENDENCIES=$(echo -n "{" && go list -tags "${BUILD_TAGS}" -f '{{range $dep := .Deps}}{{printf "%s\n" $dep}}{{end}}' | xargs go list -f '{{if not .Standard}}{{.ImportPath}}{{end}}' | xargs -I pkg bash -c 'cd $GOPATH/src/pkg && echo -n "\"pkg\":\"$(git rev-parse --short HEAD)\","' | sed 's/,$/}/')
  133. LDFLAGS="\
  134. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.buildDate=${BUILDDATE} \
  135. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.buildRepo=${BUILDREPO} \
  136. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.buildRev=${BUILDREV} \
  137. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.goVersion=${GOVERSION} \
  138. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.gomobileVersion=${GOMOBILEVERSION} \
  139. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.dependencies=${DEPENDENCIES} \
  140. "
  141. echo ""
  142. echo "Variables for ldflags:"
  143. echo " Build date: ${BUILDDATE}"
  144. echo " Build repo: ${BUILDREPO}"
  145. echo " Build revision: ${BUILDREV}"
  146. echo " Go version: ${GOVERSION}"
  147. echo " Gomobile version: ${GOMOBILEVERSION}"
  148. echo ""
  149. # Patch source files to build on Darwin
  150. IOS_CGO_BUILD_FLAGS='// #cgo darwin CFLAGS: -I'"${OPENSSL_INCLUDE}"'\
  151. // #cgo darwin LDFLAGS:'"${LIBSSL}"'\
  152. // #cgo darwin LDFLAGS:'"${LIBCRYPTO}"''
  153. LC_ALL=C sed -i -- "s|// #cgo pkg-config: libssl|${IOS_CGO_BUILD_FLAGS}|" "${OPENSSL_SRC_DIR}/build.go"
  154. # We're using a generated-code prefix to workaround https://github.com/golang/go/issues/18693
  155. ${GOPATH}/bin/gomobile bind -v -x -target ios -prefix Go -tags="${BUILD_TAGS}" -ldflags="${LDFLAGS}" -o "${INTERMEDIATE_OUPUT_DIR}/${INTERMEDIATE_OUPUT_FILE}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi
  156. rc=$?; if [[ $rc != 0 ]]; then
  157. echo "FAILURE: ${GOPATH}/bin/gomobile bind -target ios -tags="${BUILD_TAGS}" -ldflags="${LDFLAGS}" -o "${INTERMEDIATE_OUPUT_DIR}/${INTERMEDIATE_OUPUT_FILE}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi"
  158. exit $rc
  159. fi
  160. strip_architectures "${FRAMEWORK_BINARY}"
  161. #
  162. # Do the outer framework build using Xcode
  163. #
  164. # Clean previous output
  165. rm -rf "${BUILD_DIR}"
  166. rm -rf "${BUILD_DIR}-SIMULATOR"
  167. # Build the outer framework for phones...
  168. xcodebuild clean build CODE_SIGN_IDENTITY="" CODE_SIGNING_REQUIRED=NO CODE_SIGN_ENTITLEMENTS="" CODE_SIGNING_ALLOWED="NO" -configuration Release -sdk iphoneos ONLY_ACTIVE_ARCH=NO -project ${UMBRELLA_FRAMEWORK_XCODE_PROJECT} CONFIGURATION_BUILD_DIR="${BUILD_DIR}"
  169. rc=$?; if [[ $rc != 0 ]]; then
  170. echo "FAILURE: xcodebuild iphoneos"
  171. exit $rc
  172. fi
  173. # ...and for the simulator.
  174. xcodebuild clean build CODE_SIGN_IDENTITY="" CODE_SIGNING_REQUIRED=NO CODE_SIGN_ENTITLEMENTS="" CODE_SIGNING_ALLOWED="NO" -configuration Release -sdk iphonesimulator ARCHS=x86_64 VALID_ARCHS=x86_64 ONLY_ACTIVE_ARCH=NO -project ${UMBRELLA_FRAMEWORK_XCODE_PROJECT} CONFIGURATION_BUILD_DIR="${BUILD_DIR}-SIMULATOR"
  175. rc=$?; if [[ $rc != 0 ]]; then
  176. echo "FAILURE: xcodebuild iphonesimulator"
  177. exit $rc
  178. fi
  179. # Add the simulator x86_64 binary into the main framework binary.
  180. lipo -create "${BUILD_DIR}/PsiphonTunnel.framework/PsiphonTunnel" "${BUILD_DIR}-SIMULATOR/PsiphonTunnel.framework/PsiphonTunnel" -output "${BUILD_DIR}/PsiphonTunnel.framework/PsiphonTunnel"
  181. rc=$?; if [[ $rc != 0 ]]; then
  182. echo "FAILURE: lipo create"
  183. exit $rc
  184. fi
  185. # Delete the temporary simulator build files.
  186. rm -rf "${BUILD_DIR}-SIMULATOR"
  187. # Jenkins loses symlinks from the framework directory, which results in a build
  188. # artifact that is invalid to use in an App Store app. Instead, we will zip the
  189. # resulting build and use that as the artifact.
  190. cd "${BUILD_DIR}"
  191. zip --recurse-paths --symlinks build.zip * --exclude "*.DS_Store"
  192. echo "BUILD DONE"